import 'package:fl_camera/fl_camera.dart';
import 'package:flutter/material.dart';
import 'package:flutter_waya/flutter_waya.dart';

class CameraPage extends StatelessWidget {
  const CameraPage({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return ExtendedScaffold(
        body: Stack(children: <Widget>[
      FlCamera(
          onFlashChange: (FlashState state) {
            showToast('闪光灯状态$state');
          },
          overlay: Align(
            alignment: Alignment.bottomCenter,
            child: ValueBuilder<bool>(
                initialValue: false,
                builder: (_, bool? value, ValueCallback<bool> updater) {
                  value ??= false;
                  return IconBox(
                      size: 30,
                      color:
                          value ? Colors.white : Colors.white.withOpacity(0.6),
                      padding: const EdgeInsets.fromLTRB(10, 10, 10, 40),
                      icon: value ? Icons.flash_on : Icons.flash_off,
                      onTap: () async {
                        final bool state = await FlCameraMethodCall.instance
                            .setFlashMode(!value!);
                        if (state) updater(!value);
                      });
                }),
          ))
    ]));
  }
}

class ScannerBoxPage extends StatelessWidget {
  const ScannerBoxPage({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return const ExtendedScaffold(
        body: FlCamera(
            overlay: ScannerBox(
                borderColor: Colors.blue,
                scannerColor: Colors.blue,
                scannerSize: Size(300, 300),
                scannerStrokeWidth: 2)));
  }
}

class ScannerLinePage extends StatelessWidget {
  const ScannerLinePage({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return const ExtendedScaffold(
        body: FlCamera(overlay: ScannerLine(color: Colors.blue)));
  }
}
