import Flutter
import Foundation

public class FlCameraEvent: NSObject, FlutterStreamHandler {
    var eventSink: FlutterEventSink?
    var eventChannel: FlutterEventChannel?

    init(_ messenger: FlutterBinaryMessenger) {
        super.init()
        eventChannel = FlutterEventChannel(name: "fl.camera/event", binaryMessenger: messenger)
        eventChannel!.setStreamHandler(self)
    }

    public func sendEvent(_ arguments: Any?) {
        let mainQueue = DispatchQueue.main
        mainQueue.async {
            self.eventSink?(arguments)
        }
    }

    func dispose() {
        eventSink = nil
        if eventChannel != nil {
            eventChannel?.setStreamHandler(nil)
            eventChannel = nil
        }
    }

    public func onListen(withArguments arguments: Any?, eventSink events: @escaping FlutterEventSink) -> FlutterError? {
        eventSink = events
        return nil
    }

    public func onCancel(withArguments arguments: Any?) -> FlutterError? {
        dispose()
        return nil
    }
}
