import 'dart:async';

import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';

part 'src/fl_camera.dart';

part 'src/fl_camera_event.dart';

part 'src/method_call.dart';

part 'src/shade/scanner_box.dart';

part 'src/shade/scanner_line.dart';

const MethodChannel _flCameraChannel = MethodChannel(_flCamera);

const String _flCamera = 'fl.camera';

const String _flCameraEvent = '$_flCamera/event';

bool get _supportPlatform {
  if (!kIsWeb && (_isAndroid || _isIOS)) return true;
  print('Not support platform for $defaultTargetPlatform');
  return false;
}

bool get _isAndroid => defaultTargetPlatform == TargetPlatform.android;

bool get _isIOS => defaultTargetPlatform == TargetPlatform.iOS;
